import { PlusOutlined } from '@ant-design/icons';
import type { ActionType, ProColumns } from '@ant-design/pro-components';
import { Popconfirm } from 'antd';
import React, { useCallback, useRef, useState } from 'react';
import ConfigurableDrawerForm, {
  type ConfigurableDrawerFormRef,
} from '@/components/DrawerForm';
import EnhancedProTable from '@/components/EnhancedProTable';
import type { ToolbarAction } from '@/components/EnhancedProTable/types';
import { formStatusType } from '@/constants';
import {
  createTenantPackage,
  deleteTenantPackage,
  getTenantPackagePage,
  type TenantPackagePageReqVO,
  type TenantPackageVO,
  updateTenantPackage,
} from '@/services/system/tenant/package';
import { baseTenantColumns, formColumns } from './config';

const TenantPackage = () => {
  const configurableDrawerRef = useRef<ConfigurableDrawerFormRef>(null);
  const tableRef = useRef<ActionType>(null);

  const [type, setType] = useState<'create' | 'update'>('create');
  const [id, setId] = useState<number>(0);

  const handleEdit = (record: TenantPackageVO) => {
    setType('update');
    setId(record.id);

    configurableDrawerRef.current?.open(record);
  };

  const onFetch = async (
    params: TenantPackagePageReqVO & {
      pageSize?: number;
      current?: number;
    },
  ) => {
    const data = await getTenantPackagePage({
      ...params,
      pageNo: params.current,
      pageSize: params.pageSize,
    });
    return {
      data: data.list,
      success: true,
      total: data.total,
    };
  };

  const handleAdd = () => {
    setType('create');
    configurableDrawerRef.current?.open({});
  };

  const handleSubmit = useCallback(
    async (values: TenantPackageVO) => {
      if (type === 'create') {
        await createTenantPackage(values);
      } else {
        await updateTenantPackage({
          ...values,
          id,
        });
      }
      tableRef.current?.reload();
      return true;
    },
    [type, id],
  );

  const toolbarActions: ToolbarAction[] = [
    {
      key: 'add',
      label: '新建',
      type: 'primary',
      icon: <PlusOutlined />,
      onClick: handleAdd,
    },
  ];

  const actionColumns: ProColumns<TenantPackageVO> = {
    title: '操作',
    dataIndex: 'option',
    valueType: 'option',
    fixed: 'right',
    width: 120,
    render: (
      _text: React.ReactNode,
      record: TenantPackageVO,
      _: any,
      action: any,
    ) => [
      <a key="editable" onClick={() => handleEdit(record)}>
        编辑
      </a>,
      <Popconfirm
        title="是否删除?"
        key="delete"
        onConfirm={async () => {
          await deleteTenantPackage(record.id);
          action?.reload();
        }}
        okText="是"
        cancelText="否"
      >
        <a>删除</a>
      </Popconfirm>,
    ],
  };

  const columns = [...baseTenantColumns, actionColumns];
  return (
    <>
      <EnhancedProTable<TenantPackageVO>
        ref={tableRef}
        columns={columns}
        request={onFetch}
        toolbarActions={toolbarActions}
        headerTitle="租户列表"
        showIndex={false}
        showSelection={false}
      />

      <ConfigurableDrawerForm
        ref={configurableDrawerRef}
        title={formStatusType[type]}
        columns={formColumns(type)}
        onSubmit={handleSubmit}
      />
    </>
  );
};

export default TenantPackage;
